/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q;

import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;

import java.util.HashMap;

import org.apache.log4j.Logger;

public class HibernateUtilsFactory {
	
	private static transient Logger logger = Logger.getLogger(HibernateUtilsFactory.class);
	
	public static HibernateUtilsInterface getHibernateUtils(String hibernateUtils) throws EMFUserError{
		logger.debug("Begin Istantiation of HibernateUtils [" + hibernateUtils + "]");
		//TODO Add export in a XML file
		HashMap<String, String> HibernateUtilsHash = new HashMap<String, String>();

		HibernateUtilsHash.put("spago4q" ,"it.eng.spago4q.dao.S4QHibernateUtils");
		HibernateUtilsHash.put("dataAccess" ,"it.eng.spago4q.LocalHibernateUtils");
		
		HibernateUtilsInterface hUtils = null;
		
		try {
			
			logger.debug("HibernateUtils [" + hibernateUtils + "] Implementation class [" + HibernateUtilsHash.get(hibernateUtils) + "]");

			hUtils = (HibernateUtilsInterface) Class.forName(HibernateUtilsHash.get(hibernateUtils)).newInstance();
			
			logger.debug("HibernateUtils [" + hibernateUtils + "] Instatiate successfully");
		} catch (Exception se) {
			throw new EMFUserError(EMFErrorSeverity.ERROR, 1000);
		}
		return hUtils;
	}

}
