/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.dao;

import org.apache.log4j.Logger;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;


public class DAOFactory {

private static transient Logger logger = Logger.getLogger(DAOFactory.class);

	public static Object getDAO(String daoEnvEntry) throws EMFUserError {
		logger.debug("Begin Istantiation of DAO [" + daoEnvEntry + "]");
		Object daoObject = null;
		try {
			ConfigSingleton configSingleton = ConfigSingleton.getInstance();
			SourceBean daoConfigSourceBean = (SourceBean) configSingleton
					.getFilteredSourceBeanAttribute("SPAGO4Q.DAO-CONF.DAO",
							"name", daoEnvEntry);
			String daoClassName = (String) daoConfigSourceBean
					.getAttribute("implementation");
			logger.debug("DAO [" + daoEnvEntry + "] Implementation class [" + daoClassName + "]");
			daoObject = Class.forName(daoClassName).newInstance();
			logger.debug("createDAOInstance DAO [" + daoEnvEntry + "] Instatiate successfully");
		} catch (Exception se) {
			throw new EMFUserError(EMFErrorSeverity.ERROR, 1000);
		}
		return daoObject;
	}
}
/*
package it.eng.spago4q.dao;

import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;

import java.util.HashMap;

public class DAOFactory {

	public static AbstractHibernateDAO getDAO(String DAOName) throws EMFUserError{
		//TODO Add logger and export in a XML file
		HashMap<String, String> DAOHash = new HashMap<String, String>();
		DAOHash.put("EDataSourceDAO" ,"it.eng.spago4q.dao.EDataSourceDAOHibImpl");
		DAOHash.put("ESourceTypeDAO" ,"it.eng.spago4q.dao.ESourceTypeDAOHibImpl");
		DAOHash.put("EProcessDAO" ,"it.eng.spago4q.dao.EProcessDAOHibImpl");
		DAOHash.put("EInterfaceTypeDAO" ,"it.eng.spago4q.dao.EInterfaceTypeDAOHibImpl");
		DAOHash.put("EScriptDAO" ,"it.eng.spago4q.dao.EScriptDAOHibImpl");
		DAOHash.put("EInterfaceFieldDAO" ,"it.eng.spago4q.dao.EInterfaceFieldDAOHibImpl");
		DAOHash.put("EDomainValueDAO" ,"it.eng.spago4q.dao.EDomainValueDAOHibImpl");
		DAOHash.put("EDataSourceParameterDAO" ,"it.eng.spago4q.dao.EDataSourceParameterDAOHibImpl");
		DAOHash.put("EOperationDAO" ,"it.eng.spago4q.dao.EOperationDAOHibImpl");
		DAOHash.put("EOperationParameterDAO" ,"it.eng.spago4q.dao.EOperationParameterDAOHibImpl");
		DAOHash.put("EOperationFieldDAO" ,"it.eng.spago4q.dao.EOperationFieldDAOHibImpl");
		
		AbstractHibernateDAO daoObject = null;
		
		try {
			daoObject = (AbstractHibernateDAO) Class.forName(DAOHash.get(DAOName)).newInstance();
		} catch (Exception se) {
			throw new EMFUserError(EMFErrorSeverity.ERROR, 1000);
		}
		return daoObject;
	}
}
*/

