/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.extractors;

import it.eng.spago.base.SourceBean;
import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.bo.InterfaceType;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QDAO;
import it.eng.spago4q.dao.IES4QFKDAO;
import it.eng.spago4q.extractors.bo.InterfaceItem;

import java.util.List;

public class FactTableManager {
	private TableHandler tableManipulator = new TableHandler();

	public void saveFactTable(Integer interfaceTypeId) throws EMFUserError {
		IES4QDAO interfaceTypeDAO = (IES4QDAO) DAOFactory
				.getDAO("EInterfaceTypeDAO");
		InterfaceType interfaceType = (InterfaceType) interfaceTypeDAO
				.loadObjectById(interfaceTypeId);
		String query = null;
		String tableName = TableHandler.transformTableName(interfaceType
				.getTableName());
		if (tableManipulator.hasThisTable(tableName)) {
			// alterTable

		} else {
			IES4QFKDAO interfaceFieldDAO = (IES4QFKDAO) DAOFactory
					.getDAO("EInterfaceFieldDAO");
			List interfaceFieldList = interfaceFieldDAO.loadObjectList(
					interfaceType.getId(), null, null);
			query = tableManipulator.createQuery(tableName, interfaceFieldList);
		}
		tableManipulator.queryExecutor(query);
	}

	public void dropFactTable(Integer interfaceTypeId) throws EMFUserError {
		IES4QDAO interfaceTypeDAO = (IES4QDAO) DAOFactory
				.getDAO("EInterfaceTypeDAO");
		InterfaceType interfaceType = (InterfaceType) interfaceTypeDAO
				.loadObjectById(interfaceTypeId);
		String query = null;
		String tableName = TableHandler.transformTableName(interfaceType
				.getTableName());
		if (tableManipulator.hasThisTable(tableName)) {
			query = TableHandler.createDropTable(tableName);
			tableManipulator.queryExecutor(query);
		}
	}

	public boolean loadData(Integer interfaceTypeId, InterfaceItem interfaceItem, Integer logId)
			throws EMFUserError {
		boolean toReturn = false;
		IES4QDAO interfaceTypeDAO = (IES4QDAO) DAOFactory
				.getDAO("EInterfaceTypeDAO");
		InterfaceType interfaceType = (InterfaceType) interfaceTypeDAO
				.loadObjectById(interfaceTypeId);
		String selectQuery = null;
		String tableName = TableHandler.transformTableName(interfaceType
				.getTableName());
		selectQuery = TableHandler.createSelect(tableName, interfaceItem);
		SourceBean selectResult = tableManipulator.selectQueryExecutor(selectQuery);
		// if resultSet is empty -> update /insert
		if (selectResult == null || selectResult.getContainedAttributes().size() == 0) {

			String updateQuery = TableHandler.createUpdate(tableName,interfaceItem);
			tableManipulator.queryExecutor(updateQuery);
			String insertQuery = TableHandler.createInsert(tableName,interfaceItem, logId);
			tableManipulator.queryExecutor(insertQuery);
			toReturn = true;
		}
		// if resultSet > 1 the row is in the DB -> Do Noting
		if (selectResult != null && !(selectResult.getContainedAttributes().size() == 0)
				) {
			// Noting
		}
		return toReturn;
	}

}
