package it.eng.spago4q.extractors;

import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.bo.EProcess;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QDAO;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

public class DefaultCoordinatorTest extends AbstractDBTestCase {
	
	private static final String FLAT_FILE = "test/s4qFlatFile.xml";
	
	public DefaultCoordinatorTest (String value){
		super(value);
	}
	
	public void testRun(){
		DefaultCoordinator dc = new DefaultCoordinator();
		try {
			new FactTableManager().saveFactTable(1);
			IES4QDAO eProcessDAO = (IES4QDAO) DAOFactory.getDAO("EProcessDAO");
			EProcess eProcess = (EProcess)eProcessDAO.loadObjectById(2);
			
			dc.init(eProcess);
			
			dc.run();
			
			dc.run();
			new FactTableManager().dropFactTable(1);
			
		} catch (EMFUserError e) {
			fail();

		}
		
		
		
	}	
	
	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}

}
