package it.eng.spago4q.extractors;

import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.bo.InterfaceType;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QDAO;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

public class FactTableManagerTest extends AbstractDBTestCase {

	private static final String FLAT_FILE = "test/s4qFlatFile.xml";

	public FactTableManagerTest(String value) {
		super(value);
	}

	public void testSaveFactTable() {
		try {
			FactTableManager factTableManager = new FactTableManager();
			TableHandler tableManipulator = new TableHandler();
			IES4QDAO interfaceTypeDAO = (IES4QDAO) DAOFactory
					.getDAO("EInterfaceTypeDAO");
			InterfaceType interfaceType = (InterfaceType) interfaceTypeDAO
					.loadObjectById(1);
			String tableName = TableHandler.transformTableName(interfaceType.getTableName());
			factTableManager.dropFactTable(1);
			assertFalse(tableManipulator.hasThisTable(tableName));
			factTableManager.saveFactTable(1);
			assertTrue(tableManipulator.hasThisTable(tableName));
		} catch (EMFUserError e) {
			fail();
		}

	}

	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}

}
