package it.eng.spago4q.extractors;

import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

public class OperationCoordinatorFactoryTest extends AbstractDBTestCase {

	private static final String FLAT_FILE = "test/s4qFlatFile.xml";

	public OperationCoordinatorFactoryTest(String name) {
		super(name);
	}

	public void testCreate() {

		try {
			OperationCoordinatorInterface oCI = OperationCoordinatorFactory
					.create(1);
			assertEquals(DefaultCoordinator.class, oCI.getClass());

			assertEquals(1, oCI.getOperationsList().size());

			assertEquals("it.eng.spago4q.extractors.MockExtractor",
					((EOperation) oCI.getOperationsList().get(0))
							.getDataSource().getSourceType()
							.getExtractorClass());

			AbstractExtractor extractor = (AbstractExtractor) Class.forName(
					((EOperation) oCI.getOperationsList().get(0))
							.getDataSource().getSourceType()
							.getExtractorClass()).newInstance();

			extractor.init((EOperation) oCI.getOperationsList().get(0));

			assertEquals(2, extractor.getDataSourceParameter().size());
			assertEquals(1, extractor.getOperationParameter().size());

		} catch (Exception e) {
			fail();
		}
	}

	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}
}
