package it.eng.spago4q.extractors.db;


import java.util.List;

import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.extractors.AbstractExtractor;
import it.eng.spago4q.extractors.DefaultCoordinator;
import it.eng.spago4q.extractors.OperationCoordinatorFactory;
import it.eng.spago4q.extractors.OperationCoordinatorInterface;
import it.eng.spago4q.extractors.bo.GenericItemInterface;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

public class DbExtractorTest extends AbstractDBTestCase {
	
	private static final String FLAT_FILE = "test/s4qFlatFile.xml";

	public DbExtractorTest(String name){
		super(name);
	}
	
	public void testExecute(){
		try {
			OperationCoordinatorInterface oCI = OperationCoordinatorFactory.create(2);
			assertEquals(DefaultCoordinator.class, oCI.getClass());
			
			assertEquals(1,oCI.getOperationsList().size());
			
			assertEquals("it.eng.spago4q.extractors.db.DbExtractor", ((EOperation)oCI.getOperationsList().get(0)).getDataSource().getSourceType().getExtractorClass());
			
			AbstractExtractor extractor = (AbstractExtractor) Class.forName(
					((EOperation)oCI.getOperationsList().get(0)).getDataSource().getSourceType().getExtractorClass()).newInstance();

			extractor.init((EOperation)oCI.getOperationsList().get(0));
			
			assertEquals(4, extractor.getDataSourceParameter().size());
			assertEquals(1, extractor.getOperationParameter().size());
			
			List<GenericItemInterface> genericItemList =  extractor.execute();
			
			assertEquals(2, genericItemList.size());
			
		} catch (Exception e) {
			fail();
		}
		
	}

	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}
	
}
