package it.eng.spago4q.testUtils;

import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QDAO;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.DriverManager;

import org.dbunit.database.DatabaseConfig;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.dbunit.ext.hsqldb.HsqldbDataTypeFactory;
import org.dbunit.operation.DatabaseOperation;

import junit.framework.TestCase;

public abstract class AbstractDBTestCase extends TestCase {

	public AbstractDBTestCase(String value) {
		super(value);
	}

	private Connection jdbcConnection;
	
	private void setConnection (Connection connection) {
		this.jdbcConnection = connection;
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		IES4QDAO foo = (IES4QDAO) DAOFactory.getDAO("ESourceTypeDAO");
		foo.loadObjectList(null, null);

		// initialize your database connection here
		Class driverClass = Class.forName("org.hsqldb.jdbcDriver");
		setConnection( DriverManager.getConnection(
				"jdbc:hsqldb:mem:/spagobi", "sa", ""));
		IDatabaseConnection connection = new DatabaseConnection(jdbcConnection);
		DatabaseConfig config = connection.getConfig();
		config.setProperty(DatabaseConfig.PROPERTY_DATATYPE_FACTORY,
				new HsqldbDataTypeFactory());

		// initialize your dataset here
		IDataSet dataSet = new FlatXmlDataSet(new FileInputStream(
				getFlatFile()));

		try {
			DatabaseOperation.CLEAN_INSERT.execute(connection, dataSet);
		} finally {
			connection.close();
		}
	}
	
	protected abstract String getFlatFile();

}
