package it.eng.spago4q.testUtils;

import java.io.FileOutputStream;
import java.sql.Connection;
import java.sql.DriverManager;

import org.dbunit.database.DatabaseConfig;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.database.search.TablesDependencyHelper;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.dbunit.ext.mysql.MySqlDataTypeFactory;

public class DatabaseExport {

	 public static void main(String[] args) throws Exception
	    {
		 	System.out.println("DataBase export is started!");
	        // database connection
	        Class driverClass = Class.forName("com.mysql.jdbc.Driver");
	        Connection jdbcConnection = DriverManager.getConnection(
	                "jdbc:mysql://localhost:3306/spagobi", "spagobi", "bispago");
	        IDatabaseConnection connection = new DatabaseConnection(jdbcConnection);
	        DatabaseConfig config = connection.getConfig();
	        config.setProperty(DatabaseConfig.PROPERTY_DATATYPE_FACTORY, new MySqlDataTypeFactory());

	        

//	        // partial database export
//	        QueryDataSet partialDataSet = new QueryDataSet(connection);
//	        partialDataSet.addTable("FOO", "SELECT * FROM TABLE WHERE COL='VALUE'");
//	        partialDataSet.addTable("BAR");
//	        FlatXmlDataSet.write(partialDataSet, new FileOutputStream("partial.xml"));
//
//	        // full database export
//	        IDataSet fullDataSet = connection.createDataSet();
//	        FlatXmlDataSet.write(fullDataSet, new FileOutputStream("full.xml"));
	        
	        // dependent tables database export: export table X and all tables that
	        // have a PK which is a FK on X, in the right order for insertion
	        String[] depTableNames = 
	          TablesDependencyHelper.getAllDependentTables( connection, "s4q_e_operation" );
	        IDataSet depDataset = connection.createDataSet( depTableNames );
	        FlatXmlDataSet.write(depDataset, new FileOutputStream("test/s4qFlatFile2.xml"));
	        System.out.println("DataBase export is finished!");
	        
	    }

	
}
